## metview 4.6.1

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( metview C CXX Fortran)


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()


set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

set(METVIEW_INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )


ecbuild_requires_macro_version( 1.9 )

ecbuild_enable_fortran( REQUIRED )


###############################################################################
# some options of this project

option( ENABLE_UI            "enable the user interface"                          ON )
option( ENABLE_MOTIF         "enable the classic Motif-based user interface"      OFF )
option( ENABLE_PLOTTING      "enable the plotting module"                         ON )
option( ENABLE_OPERA_RADAR   "enable OPERA radar filter module (requires proj4)"  AUTO )
option( ENABLE_MARS          "enable MARS access"                                 OFF )
option( ENABLE_ODB           "enable ODB"                                         OFF )
option( ENABLE_MARS_ODB      "enable ODB in MARS"                                 OFF )
option( ENABLE_USAGE_LOG     "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG      "enable Qt debugging messages"                       OFF )
option( ENABLE_QT5           "enable Qt5"                                         OFF )
option( ENABLE_INPE          "enable INPE modules"                                ON )
option( ENABLE_WEATHER_ROOM  "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_NETWORK_PROXY "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL  "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB       "enable externally contributed modules"              OFF )
 
###############################################################################


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    message("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    message("Building inside ECMWF")
endif()


if(DEFINED EXTRA_CONFIG_PATH)
    message(STATUS "Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        ecbuild_add_extra_search_paths( boost ) # Weather Room export needs Boost
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        message(WARNING "ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()


if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()


# --------------------------------
# look for MARS client source code
# --------------------------------

if(MARS_SOURCE_PATH)
    # if the user specified a path, then only look there
    set(MARS_SOURCE_PATHS ${MARS_SOURCE_PATH}/src)
else()
    # otherwise look in some default locations
    set(MARS_SOURCE_PATHS ${CMAKE_SOURCE_DIR}/src/libMars         # embedded in source
                          ${CMAKE_SOURCE_DIR}/src/libMarsClient   # embedded in source
                          ${CMAKE_SOURCE_DIR}/mars-client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/mars_client/src     # bundle
                          ${CMAKE_SOURCE_DIR}/../client/src       # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars-client/src  # in external dir
                          ${CMAKE_SOURCE_DIR}/../mars_client/src) # in external dir
endif()

ecbuild_debug("Looking for MARS source in ${MARS_SOURCE_PATHS}")
find_path( MARS_SOURCE request.c
           HINTS ${MARS_SOURCE_PATHS}
           PATH_SUFFIXES src
           DOC "Path to MARS client source code"
           NO_DEFAULT_PATH )

if (MARS_SOURCE)
    message(STATUS "Found MARS source at ${MARS_SOURCE}")
else()
    message(FATAL_ERROR "MARS source is required, but was not found in " ${MARS_SOURCE_PATHS})
endif()


# ensure the MARS client source is included in the tarball (if necessary)
if(NOT ${MARS_SOURCE} STREQUAL ${CMAKE_SOURCE_DIR}/src/libMars)
    list( APPEND CPACK_SOURCE_INSTALLED_DIRECTORIES
            "${MARS_SOURCE}" "src/libMarsClient")
endif()



# look for curl because it is needed for the Mars Web API client
find_package(CURL)

# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        message(STATUS "MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            message(FATAL_ERROR "MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        message(FATAL_ERROR "If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()

    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #message(STATUS "FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        message(STATUS "Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


if(AT_ECMWF)
    ecbuild_use_package( PROJECT FDB REQUIRED )
else()
    ecbuild_use_package( PROJECT FDB )
endif()

message(STATUS "FDB: ${FDB_LIBRARIES}" )

if( NOT FDB_FOUND )
    message(STATUS "NO FDB" )
endif()



###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

ecbuild_use_package( PROJECT grib_api VERSION 1.13.0 REQUIRED )


if(ENABLE_ODB)
    ecbuild_use_package( PROJECT odb_api  VERSION 0.10.1 ) # requires at least this version
    if( ODB_API_FOUND )

        set( METVIEW_ODB_API_LIBRARIES Odb )
        # does this version use eckit?
        list(FIND ODB_API_LIBRARIES eckit ODB_ECKIT_INDEX)
   

        if ((NOT ODB_ECKIT_INDEX EQUAL -1) OR (DEFINED ODB_ECKIT))  # is an eckit version
            if (DEFINED SEPARATE_ECKIT)
                ecbuild_use_package( PROJECT eckit VERSION 0.6 REQUIRED )
            endif()
            add_definitions(-DODB_ECKIT)
        endif()

        set(METVIEW_ODB 1)

        if(ODB_API_PATH)
            set(ODB_API_LIB_DIR ${ODB_API_PATH}/lib)
            set(ODB_API_BIN_DIR ${ODB_API_PATH}/bin)
        endif()

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
        set(METVIEW_ODB_API_INCLUDE_DIRS ${ODB_API_INCLUDE_DIRS}
                                         ${ODB_API_INCLUDE_DIRS}/..
                                         ${ODB_API_INCLUDE_DIRS}/../eclib
                                         ${ODB_API_INCLUDE_DIRS}/../eclib/eclib
                                         ${ODB_API_INCLUDE_DIRS}/odblib
                                         ${ECKIT_INCLUDE_DIRS}) 
    else()
        if(ENABLE_MARS_ODB)
            message(FATAL_ERROR "ENABLE_ODB was set, but ODB not found")
#            message(FATAL_ERROR "ENABLE_MARS_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()
    ###list( APPEND METVIEW_TPLS odb_api )


    # ODB-1

    ecbuild_use_package( PROJECT ODB )
    
    if(ODB_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")
                endif()

                if(ODB1_VERSION) # was an ODB-1 module name passed?
                    set(MV_ODB1_VERSION ${ODB1_VERSION})
                else()
                    set(MV_ODB1_VERSION "ANY")
                endif()

            else()
                message(WARNING "ODB-1 support is DISABLED - No odbsql script found in ${ODB_PATH}/bin")
            endif()
        else()
            message(WARNING "ODB-1 found, but no bin directory in ${ODB_PATH}")
        endif()
    else()
        message(WARNING "ODB-1 not found!")
    endif()
endif()


ecbuild_use_package( PROJECT libemos VERSION 4.0.5 REQUIRED )

if(ENABLE_PLOTTING)
    ecbuild_use_package( PROJECT magics VERSION 2.24.3)
    if( MAGICS_FOUND )

        set(MAGICS_LIB_DIR "${magics_BASE_DIR}/lib")

        if(NOT MAGICS_HAVE_METVIEW)
            message(FATAL_ERROR "Magics must be built with Metview support!")
        endif()

        if(NOT MAGICS_HAVE_NETCDF)
            message(FATAL_ERROR "Magics must be built with netCDF support!")
        endif()

        if(MAGICS_HAVE_ODB)
            add_definitions(-DMETVIEW_ODB_PLOT)
        else()
            if(ENABLE_ODB)
                message(STATUS "ODB plotting is disabled, because Magics was built without ODB support! Please, rebuild Magics with ODB support to enable ODB plotting!")  #xxx should be at end
            endif()
        endif()

        if(NOT MAGICS_HAVE_CAIRO)
            message(STATUS "NO PNG and PDF plotting support (disabled in Magics)")  #xxx should be at end
        endif()

        if(NOT MAGICS_HAVE_BUFR)
            message(STATUS "NO BUFR plotting support (disabled in Magics)")  #xxx should be at end
        endif()

    else()
        message(FATAL_ERROR "Magics was not found, and it is required if ENABLE_PLOTTING=ON. Please supply MAGICS_PATH if necessary.")
    endif()
endif()


ecbuild_declare_project()
message(STATUS "VERSION: ${METVIEW_VERSION_STR}")

###############################################################################
# Find external dependencies

#set( CMAKE_THREAD_PREFER_PTHREAD 1 )

=== bin/CMakeLists.txt ===
if( ENABLE_INSTALL )
	install( PROGRAMS ecbuild DESTINATION ${INSTALL_BIN_DIR} )
endif()

=== scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh)
endif()



# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})




##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro


# find the actual path to the emoslib library
get_property(EMOS_LIB_PATH TARGET emos PROPERTY LOCATION)


# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning
list(REMOVE_ITEM GRIB_API_LIBRARIES_STR "debug")     # remove non-compiler items from the string
list(REMOVE_ITEM GRIB_API_LIBRARIES_STR "optimized") # remove non-compiler items from the string

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
string (REPLACE ";"         " "           EMOS_LIBRARIES_STR        "${EMOS_LIB_PATH}")


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed
set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later

# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).
# GRIB_API_LIB_DIR will be added to METVIEW_LD_PATHS and used in compile.in.

# first, if GRIB_API_PATH is not defined, then we need to compute the path
if(NOT GRIB_API_PATH)
    get_property(GRIB_LIB_PATH TARGET grib_api PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    message(STATUS "Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    if(EXISTS "${GRIB_API_PATH}/lib")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib")
    else()
    endif()

    if(EXISTS "${GRIB_API_PATH}/lib64")
        set(GRIB_API_LIB_DIR "${GRIB_API_PATH}/lib64")
    endif()

    set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64 ${GRIB_API_LIBRARIES_STR}")
endif()


foreach (inc ${GRIB_API_INCLUDE_DIRS})
    set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
endforeach()



list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

if(DEFINED METVIEW_BUNDLE)
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"    EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
endif()

configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# CONFIG.site

if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(DEFINED METVIEW_BUNDLE)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(DEFINED METVIEW_BUNDLE_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()



ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
#     list(FIND SYS_LIBDIRS ${LIBPATH} IND)
#     if(IND EQUAL -1)  # path not in the list of system paths
#         set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
#     endif()
# endforeach()


# create the Metview startup script
configure_file(metview_base.in ${FULL_STARTUP_SCRIPT_PATH} @ONLY)


# create a 'production' version of this - just the same, but with
# METVIEW_VERSION=prod instead of dev

set(PROD_TEMPORARY_STARTUP_SCRIPT "${FULL_STARTUP_SCRIPT_PATH}_prod")

add_custom_command( 
    OUTPUT  ${PROD_TEMPORARY_STARTUP_SCRIPT}
    COMMAND sed "s/METVIEW_VERSION=dev/METVIEW_VERSION=prod/g" ${FULL_STARTUP_SCRIPT_PATH} > ${PROD_TEMPORARY_STARTUP_SCRIPT}
    DEPENDS ${FULL_STARTUP_SCRIPT_PATH}
)


ADD_CUSTOM_TARGET(mvs ALL DEPENDS ${FULL_STARTUP_SCRIPT_PATH} ${PROD_TEMPORARY_STARTUP_SCRIPT})


# when we install, we actually want to install the production script and rename it
install( FILES       ${PROD_TEMPORARY_STARTUP_SCRIPT}
         RENAME      ${METVIEW_SCRIPT}
         DESTINATION bin # NOT ${MV_BIN_DIR}!
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)



## TODO
## If we are building this outside ECMWF, then we want different proxy settings
## (used currently by the OGC clients). We achieve this by simply changing the
## default setting in the ConfigDef file. We can do this with a  a search/replace
## operation. This relies very much on the proxy setting having a uniqe 'signature'
## so that the search/replace can operate on a single line.
#
#if test "x$SITE_NAME" != 'xecmwf'; then
#    configdef=share/metview/etc/ConfigDef
#    configtmp=${configdef}.tmp
#    echo "Not at ECMWF: resetting the default proxy setting in ${configdef}."
#    chmod u+w $configdef
#    sed "s/	} = yes/	} = no/g"  $configdef > $configtmp
#    mv $configtmp $configdef
#fi

#ecbuild_dont_pack(FILES mv_cp metview_local.ecmwf metview_local2.ecmwf)

ecbuild_dont_pack(REGEX "metview_local*.ecm*")
ecbuild_dont_pack(FILES "mv_cp;mv_debug_env.sh;update_MetApps_files.sh")

=== src/CMakeLists.txt ===

add_subdirectory( libMars )
add_subdirectory( libUtil )
add_subdirectory( libMetview )
add_subdirectory( libMvNetCDF )
add_subdirectory( libFTimeUtil )

add_subdirectory( Datacoverage )
add_subdirectory( Divrot )
add_subdirectory( Ecfile )
add_subdirectory( Event )

add_subdirectory( Macro )
add_subdirectory( MvApp )
add_subdirectory( Flextra )
add_subdirectory( GribVectors )
add_subdirectory( Hovmoeller )
add_subdirectory( KML )
add_subdirectory( ObsFilter )
add_subdirectory( Percentile )
add_subdirectory( PottF )
add_subdirectory( Relhum )
add_subdirectory( Rttov )
add_subdirectory( Scm )
add_subdirectory( Spectra )
add_subdirectory( Stations )
add_subdirectory( StdAppManager )
add_subdirectory( Thermo )
add_subdirectory( Velstr )
add_subdirectory( Vapor )
add_subdirectory( XSection )

if(ENABLE_INPE)
    add_subdirectory(CptecAccess)
endif()

if(ENABLE_OPERA_RADAR)
    add_subdirectory(OperaRadar)
endif()

if(ENABLE_UI)
    if(ENABLE_MOTIF)
        add_subdirectory(libMvMotif)
        add_subdirectory(WebAccess)
   endif()

    add_subdirectory(libMvQtUtil)
    add_subdirectory(libMvQtGui)
    add_subdirectory(AppMod)
    add_subdirectory(BufrExaminer)
    add_subdirectory(DebugTools)
    add_subdirectory(ExamineManager)
    add_subdirectory(FlextraExaminer)
    add_subdirectory(GeopExaminer)
    add_subdirectory(GribExaminer)
    add_subdirectory(MacroEditor)
    add_subdirectory(NcExaminer)
    add_subdirectory(OgcClient)
    add_subdirectory(ScmEditor)
 
    if(ENABLE_MOTIF)
        add_subdirectory(MetviewUI)
    endif()

    # omitted: VisTools


    if(ENABLE_EXPERIMENTAL)
        add_subdirectory(MarsCatalog)
    endif()

    add_subdirectory(Desktop)
endif()


if(ENABLE_PLOTTING)
    add_subdirectory(uPlot)
    add_subdirectory(MagML)
    add_subdirectory(Reprojection)

    if(AT_ECMWF)
        add_subdirectory(Meteogram)
    endif()
endif()


if(ENABLE_ODB)
    add_subdirectory(Odb)
    if(ENABLE_UI)
        add_subdirectory(OdbExaminer)
    endif()
endif()


# still to do:
#     ensure that contents of images directory are put into tarball

# will not do:  libMars-ecregrid Obstat ObstatCurveTool ObstatScatterTool




# propagate ModuleObjectSpecFiles to the parent scope so we can use it again
set(ModuleObjectSpecFiles ${ModuleObjectSpecFiles} PARENT_SCOPE)
set(ModuleXpmFiles        ${ModuleXpmFiles}        PARENT_SCOPE)
set(ModuleSvgFiles        ${ModuleSvgFiles}        PARENT_SCOPE)

=== src/AppMod/CMakeLists.txt ===

if(METVIEW_QT5)
 QT5_WRAP_CPP(savepool_MOC savepool.h)
else()
 QT4_WRAP_CPP(savepool_MOC savepool.h)
endif()

ecbuild_add_executable( TARGET       savepool 
                        SOURCES      savepool.cc ${savepool_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${FDB_LIBRARIES}
                    )
######## xxxxx ODB????



ecbuild_add_executable( TARGET       MvMailTo
                        SOURCES      MvMailTo.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )


ecbuild_add_executable( TARGET       MvCompress
                        SOURCES      MvCompress.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

if(ENABLE_MOTIF)

ecbuild_add_executable( TARGET       exampool
                        SOURCES      examcback.cc exammain.c examwidgets.h
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_MOTIF_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )


ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/maill.c
	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/maill.l\; sed -e s/yy/mail/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/maill.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/maill.l)

ADD_CUSTOM_TARGET(maillex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/maill.c)

ecbuild_add_executable( TARGET       mvnews
                        SOURCES      newsmain.c newscback.c maill.c
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_MOTIF_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )
ADD_DEPENDENCIES(mvnews maillex)


ecbuild_add_executable( TARGET       mvmail
                        SOURCES      mailmain.c mailcback.c
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_MOTIF_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

ecbuild_add_executable( TARGET       checkdisplay
                        SOURCES      checkdisplay.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_MOTIF_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

endif()

=== src/ExamineManager/CMakeLists.txt ===

ecbuild_add_executable( TARGET       MvExamineManager
                        SOURCES      MvExamineManager.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

=== src/GribExaminer/CMakeLists.txt ===

if(METVIEW_QT5)
 QT5_WRAP_CPP(Grib_MOC GribExaminer.h)
else()
 QT4_WRAP_CPP(Grib_MOC GribExaminer.h)
endif()


ecbuild_add_executable( TARGET       GribExaminer
                        SOURCES      MvMain.cc GribExaminer.cc  MvQGribDumpModel.cc GribExaminer.h MvQGribDumpModel.h ${Grib_MOC}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS}
                    )

=== src/MacroEditor/CMakeLists.txt ===

if(METVIEW_QT5)
 QT5_WRAP_CPP      (MacroEd_MOC MvMain.h FindTextDialog.h Highlighter.h MacroEdit.h FunctionListDialog.h mvplaintextedit.h
                   CodeTemplateDialog.h GotoLineDialog.h RunDialog.h TabsDialog.h VerbFunctionHelpDialog.h MacroEdit.h)
 QT5_ADD_RESOURCES (MacroEd_RES MacroEdit.qrc)
 QT5_WRAP_UI       (MacroEd_FORMS_HEADERS CodeTemplateDialog.ui FunctionListDialog.ui VerbFunctionHelpDialog.ui
                   FindTextDialog.ui MacroEdit.ui GotoLineDialog.ui RunDialog.ui TabsDialog.ui)
else()
 QT4_WRAP_CPP      (MacroEd_MOC MvMain.h FindTextDialog.h Highlighter.h MacroEdit.h FunctionListDialog.h mvplaintextedit.h
                   CodeTemplateDialog.h GotoLineDialog.h RunDialog.h TabsDialog.h VerbFunctionHelpDialog.h MacroEdit.h)
 QT4_ADD_RESOURCES (MacroEd_RES MacroEdit.qrc)
 QT4_WRAP_UI       (MacroEd_FORMS_HEADERS CodeTemplateDialog.ui FunctionListDialog.ui VerbFunctionHelpDialog.ui
                   FindTextDialog.ui MacroEdit.ui GotoLineDialog.ui RunDialog.ui TabsDialog.ui)
endif()

set(macroeditor_srcs MvMain.cc
                     Highlighter.cc
                     MacroEdit.cc
                     CodeTemplateDialog.cc
                     FindTextDialog.cc
                     GotoLineDialog.cc
                     RunDialog.cc
                     TabsDialog.cc
                     FunctionListDialog.cc
                     VerbFunctionHelpDialog.cc
                     mvplaintextedit.cc
                     MacroHelper.cc
                     MagMLHelper.cc
                     ShellHelper.cc
                     PlainTextHelper.cc
                     LanguageHelper.cc
                     LanguageHelperFactory.cc
                     VerbFunctionHelp.cc
                     CodeTemplateDialog.h
                     FindTextDialog.h
                     FunctionListDialog.h
                     GotoLineDialog.h
                     Highlighter.h
                     LanguageHelper.h
                     LanguageHelperFactory.h
                     MacroEdit.h
                     MacroHelper.h
                     MagMLHelper.h
                     ShellHelper.h
                     MvMain.h
                     PlainTextHelper.h
                     RunDialog.h
                     MacroRunOptions.h
                     TabsDialog.h
                     TabsSettings.h
                     VerbFunctionHelp.h
                     VerbFunctionHelpDialog.h
                     mvplaintextedit.h)

#include_directories( CMAKE_CURRENT_BINARY_DIR . )

ecbuild_add_executable( TARGET       MacroEditor
                        SOURCES      ${MacroEd_FORMS_HEADERS}
                                     ${MacroEd_MOC}
                                     ${MacroEd_RES}
                                     ${macroeditor_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
                                     ${METVIEW_STANDARD_INCLUDES} ${X11_INCLUDE_DIR} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${X11_LIBRARIES}
                    )

=== src/Meteogram/CMakeLists.txt ===

ecbuild_add_executable( TARGET       MetPlus
                        SOURCES      MetPlus.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                      )


metview_module_files(ETC_FILES ObjectSpec.Meteogram
                               MetPlusDef
                               MetPlusRules
                     XPM_FILES MetPlus.xpm)



set(local_metgram_script ${CMAKE_BINARY_DIR}/bin/metgram_client)

configure_file(${MAGICS_METEOGRAM_SCRIPT} ${local_metgram_script} COPYONLY)

install(FILES ${local_metgram_script}
        DESTINATION ${MV_BIN_DIR}
        PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== src/MetviewUI/CMakeLists.txt ===
 
set(MetviewUI_srcs
    Action.cc
    ActionCommand.cc
    Ask.cc
    Basic.cc
    BoolLine.cc
    ColorLine.cc
    ColorName.cc
    ColorHelp.cc
    ColourEditor.cc
    Command.cc
    ComputeEditor.cc
    ConfigLoader.cc
    Confirm.cc
    Counted.cc
    Dependancy.cc
    DragWindow.cc
    Drawer.cc
    Drop.cc
    DropSite.cc
    Dropping.cc
    MotifDrop.cc
    EditTransaction.cc
    Editor.cc
    EditorDrawer.cc
    EditorDrawerFactory.cc
    EditorFactory.cc
    EditorTool.cc
    EditorToolFactory.cc
    ExternalHelp.cc
    Family.cc
    FamilyHelper.cc
    FamilyEditor.cc
    FileObject.cc
    FileSelection.cc
    Folder.cc
    FolderDrawers.cc
    FolderViewer.cc 
    FolderWindow.cc
    HelpFactory.cc
    IconClass.cc
    IconDrawer.cc
    IconFactory.cc
    IconHelp.cc
    IconHolder.cc
    IconInfo.cc
    IconLine.cc
    IconObject.cc
    IconSelection.cc
    Input.cc
    InternalService.cc
    InternalTask.cc
    ViewsDrawer.cc
    Items.cc
    Language.cc
    LayoutDrawer.cc
    LineFactory.cc
    ListHelp.cc
    Log.cc
    TeeBuffer.cc
    TeeStream.cc
    LogWindow.cc
    Netscape.cc
    Help.cc
    MacroEditor.cc
    MacroParam.cc
    MacroParamEditor.cc
    MacroParamState.cc
    MacroRunTask.cc
    MenuLine.cc
    NoneLine.cc
    MessageObserver.cc 
    MethodCommand.cc
    MetviewService.cc
    MetviewTask.cc
    MetviewUI.cc
    NoEditor.cc
    InternalEditor.cc
    ExternalEditor.cc
    ExternalTextEditor.cc
    ExternalServiceEditor.cc
    BaseTextEditor.cc
    OutputDrawer.cc
    CatalogDrawer.cc
    GridDrawer.cc
    PageView.cc
    PaperDrawer.cc
    ParamList.cc
    Parameter.cc
    PlotModHelp.cc
    Protocol.cc
    Queue.cc
    QtMacroEditor.cc
    QtOgcClientEditor.cc
    QtScmEditor.cc
    QtStackedEditor.cc
    Rainbow.cc
    Recents.cc
    ReplyObserver.cc 
    RequestPanel.cc
    RequestPanelHelp.cc
    RequestPanelItem.cc	
    RequestPanelLine.cc
    ResolveTransaction.cc
    Resources.cc
    RootFolder.cc
    ScaleLine.cc
    ScriptHelp.cc
    Service.cc
    ShellService.cc
    ShellTask.cc
    SimpleEditor.cc
    RetrieveEditor.cc
    ScrolledText.cc
    State.cc
    StationaryDrawers.cc
    SyncFolders.cc 
    SystemFolder.cc
    Task.cc
    TempIconClass.cc
    TemplateDrawer.cc
    Temporary.cc
    TemporaryFolder.cc
    TextEditor.cc
    TextLine.cc
    Timeout.cc
    Runnable.cc
    StringLine.cc
    Tools.cc
    Transaction.cc
    Unknown.cc
    UserMessage.cc
    ViewEditor.cc
    ODBEditor.cc
    SQLDrawer.cc
    ODBFunctionsDrawer.cc
    Wastebasket.cc
    XMLabel.cc
    XMList.cc
    XMString.cc
    XMText.cc
    XPalette.cc
    XPixmap.cc
    XResource.cc
    main.cc
    UIAsk.cc
    UIBoolLine.cc
    UIColorLine.cc
    UIColorName.cc
    UIColourEditor.cc
    UIConfirm.cc
    UIEditor.cc
    UIFamilyEditor.cc
    UIFileSelection.cc
    UIFolderWindow.cc
    UIIconDrawer.cc
    UIIconHelp.cc
    UIIconLine.cc
    UIIconSelection.cc
    UILayoutDrawer.cc
    UILine.cc
    UINoneLine.cc
    UIColorHelp.cc
    UIListHelp.cc
    UILogWindow.cc
    UIGridDrawer.cc
    UIMenuLine.cc
    UINoEditor.cc
    UIOutputDrawer.cc
    UICatalogDrawer.cc
    UIPaperDrawer.cc
    UIParamEditor.cc
    UIRequestPanel.cc
    UIScaleLine.cc
    UIScriptHelp.cc
    UIScrolledText.cc
    UISimpleEditor.cc
    UITemplateDrawer.cc
    UITextEditor.cc
    UITextLine.cc
    UISyncFolders.cc
    UIViewsDrawer.cc
    UIODBEditor.cc
    UIODBFunctionsDrawer.cc
    UISQLDrawer.cc
    UIViewEditor.cc
    Action.h
    ActionCommand.h
    Ask.h
    BaseTextEditor.h
    Basic.h
    BoolLine.h
    CatalogDrawer.h
    ColorHelp.h
    ColorLine.h
    ColorName.h
    ColourEditor.h
    Command.h
    CommandObserver.h
    ComputeEditor.h
    ConfigLoader.h
    Confirm.h
    Counted.h
    Dependancy.h
    Dialog.h
    DragWindow.h
    Drawer.h
    Drop.h
    DropSite.h
    Dropping.h
    EditTransaction.h
    Editor.h
    EditorButton.h
    EditorDrawer.h
    EditorDrawerFactory.h
    EditorFactory.h
    EditorObserver.h
    EditorTool.h
    EditorToolFactory.h
    Error.h
    Extent.h
    ExternalEditor.h
    ExternalHelp.h
    ExternalServiceEditor.h
    ExternalTextEditor.h
    Family.h
    FamilyEditor.h
    FamilyHelper.h
    FileObject.h
    FileSelection.h
    Folder.h
    FolderDrawers.h
    FolderObserver.h
    FolderViewer.h
    FolderWindow.h
    GridDrawer.h
    HSLMaker.h
    Help.h
    HelpFactory.h
    IconClass.h
    IconDrawer.h
    IconFactory.h
    IconHelp.h
    IconHolder.h
    IconInfo.h
    IconLine.h
    IconObject.h
    IconObserver.h
    IconSelection.h
    Input.h
    InternalEditor.h
    InternalService.h
    InternalTask.h
    Items.h
    Language.h
    LayoutDrawer.h
    LineFactory.h
    ListHelp.h
    Log.h
    LogWindow.h
    MacroEditor.h
    MacroParam.h
    MacroParamEditor.h
    MacroParamState.h
    MacroRunTask.h
    MenuLine.h
    Message.h
    MessageObserver.h
    MethodCommand.h
    MetviewService.h
    MetviewTask.h
    MetviewUI.h
    MotifDrop.h
    Netscape.h
    NoEditor.h
    NoneLine.h
    ODBEditor.h
    ODBFunctionsDrawer.h
    OutputDrawer.h
    PageView.h
    PaperDrawer.h
    ParamList.h
    Parameter.h
    PlotModHelp.h
    Protocol.h
    QtMacroEditor.h
    QtOgcClientEditor.h
    QtScmEditor.h
    QtStackedEditor.h
    Queue.h
    RGBMaker.h
    Rainbow.h
    Recents.h
    ReplyObserver.h
    RequestPanel.h
    RequestPanelHelp.h
    RequestPanelItem.h
    RequestPanelLine.h
    ResolveTransaction.h
    Resources.h
    RetrieveEditor.h
    RootFolder.h
    Runnable.h
    SQLDrawer.h
    ScaleLine.h
    ScriptHelp.h
    ScrolledText.h
    Service.h
    ShellService.h
    ShellTask.h
    SimpleDroppin.h
    SimpleEditor.h
    Singleton.h
    State.h
    StationaryDrawers.h
    StringLine.h
    SyncFolders.h
    SynchFolders.h
    SystemFolder.h
    Task.h
    TaskObserver.h
    TeeBuffer.h
    TeeStream.h
    TempIconClass.h
    TemplateDrawer.h
    Temporary.h
    TemporaryFolder.h
    TextEditor.h
    TextLine.h
    Timeout.h
    Tools.h
    Transaction.h
    UIAsk.h
    UIBoolLine.h
    UICatalogDrawer.h
    UIColorHelp.h
    UIColorLine.h
    UIColorName.h
    UIColourEditor.h
    UIConfirm.h
    UIEditor.h
    UIFamilyEditor.h
    UIFileSelection.h
    UIFolderWindow.h
    UIGridDrawer.h
    UIIconDrawer.h
    UIIconHelp.h
    UIIconLine.h
    UIIconSelection.h
    UILayoutDrawer.h
    UILine.h
    UIListHelp.h
    UILogWindow.h
    UIMenuLine.h
    UINoEditor.h
    UINoneLine.h
    UIODBEditor.h
    UIODBFunctionsDrawer.h
    UIOutputDrawer.h
    UIPaperDrawer.h
    UIParamEditor.h
    UIRequestPanel.h
    UISQLDrawer.h
    UIScaleLine.h
    UIScriptHelp.h
    UIScrolledText.h
    UISimpleEditor.h
    UISyncFolders.h
    UITemplateDrawer.h
    UITextEditor.h
    UITextLine.h
    UIViewEditor.h
    UIViewsDrawer.h
    Unknown.h
    UserMessage.h
    VariableTask.h
    ViewEditor.h
    ViewsDrawer.h
    Wastebasket.h
    XMLabel.h
    XMList.h
    XMString.h
    XMText.h
    XPalette.h
    XPixmap.h
    XResource.h
    auto_ptr.h
)

include_directories( CMAKE_CURRENT_SOURCE_DIR . )

ecbuild_add_executable( TARGET       MetviewUI
                        SOURCES      ${MetviewUI_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${X11_INCLUDE_DIR} ${METVIEW_STANDARD_INCLUDES} ${METVIEW_MOTIF_INCLUDE_DIR}
                        LIBS         ${METVIEW_MOTIF_LIBS} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES} ${MOTIF_LIBRARIES} ${X11_LIBRARIES}
                    )

=== src/ObsFilter/CMakeLists.txt ===

ecbuild_add_executable( TARGET       ObsFilter
                        SOURCES      ObsFilter.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

ecbuild_add_executable( TARGET       CleanFile
                        SOURCES      CleanFile.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

ecbuild_add_executable( TARGET       BufrPicker
                        SOURCES      BufrPicker.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )



metview_module_files(ETC_FILES  ObjectSpec.BufrPicker BufrPickerDef BufrPickerRules)

=== src/Odb/CMakeLists.txt ===

ecbuild_add_executable( TARGET       OdbFilter
                        SOURCES      OdbFilter.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_ODB_API_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_ODB_API_LIBRARIES} 
                    )

ecbuild_add_executable( TARGET       OdbVisualiser
                        SOURCES      OdbVisualiser.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_ODB_API_INCLUDE_DIRS}
                        LIBS         ${STANDARD_METVIEW_LIBS} ${METVIEW_ODB_API_LIBRARIES}
                    )

metview_module_files(ETC_FILES ObjectSpec.Odb
                               OdbFilterDef
                               OdbFilterRules
                               OdbVisualiserDef
                               OdbVisualiserRules)

=== debian/changelog ===
metview (4.6.1-5build1) xenial; urgency=medium

  * No-change rebuild for dxflib transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2016 08:10:32 +0000

metview (4.6.1-5) unstable; urgency=medium

  * Remove B-D on libmotif-dev as it is no longer used (Qt5 is instead)
  * Split dh_fixperms to arch and -indep parts, so dpkg-buildpackage -A
    works. Closes: #814437.
  * Fix bashisms. Closes: #772310.
  * Patch for G++ 6 changes (c++-11 abi). Closes: #812161.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Feb 2016 23:02:36 +0000

metview (4.6.1-4) unstable; urgency=medium

  * Fix for --no-arch-all builds

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jan 2016 03:08:30 +0000

metview (4.6.1-3) unstable; urgency=medium

  * compress files 'gzip -n' for reproducibility. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jan 2016 07:23:27 +0000

metview (4.6.1-2) unstable; urgency=medium

  * Depend on libgrib-api-dev >= 1.14.4-5 to pull in its Build-dependencies.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Jan 2016 13:21:31 +0000

metview (4.6.1-1) unstable; urgency=medium

  * New upstream release.
    * qt5.patch now merged upstream.
  * B-D on magics >= 2.26.2-1
  * metview explicitly depends on ksh. Closes: #808815.
  * Fix path in metview script. Closes: #808816.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Jan 2016 07:36:31 +0000

metview (4.5.7-3) unstable; urgency=medium

  * Next in the round of exciting metview reproducibility fixes. 
    Closes: #806580.
  * Use -fPIC on i386
  * Link "--as-needed"
  * Define PATH_MAX in mars.h for Hurd FTBFS.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Dec 2015 14:14:19 +0000

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), 
  flex, bison, libhdf5-dev, libpango1.0-dev, chrpath, ksh,
  libqt5webkit5-dev, qtbase5-dev, libqt5xmlpatterns5-dev,
  libgrib-api-dev, libgrib-api-tools,
  libemos-dev (>= 2:4.1.1-2), libboost-dev,
  libmagics++-metview-dev, libmagics++-dev (>= 2.26.2),
  libxmu-dev, libgdbm-dev, libcurl4-gnutls-dev,
  libcairo2-dev, pkg-config, swig, libexpat1-dev,
  libterralib-dev, ksh, libproj-dev,
  libgd-dev, imagemagick, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  libopenjpeg-dev, cmake, flextra, gfortran, libgeotiff-dev
Standards-Version: 3.9.6
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Git: git://anonscm.debian.org/debian-science/packages/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh, 
 x11-utils, metview-data, python
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview-dev
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
export QT_SELECT=5

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
PATH:=$(PATH):$(CURDIR)/scripts
AUTOGENERATED:= libmetview-dev.install  metview.install
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin

FPIC:= ''

ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=$(METVIEW_DIR_DEV)

override_dh_auto_clean:
	dh_clean
	rm -rf $(METVIEW_DIR_DEV)
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	[ ! -f scripts/metview_base.in.bak ] || \
		( mv scripts/metview_base.in.bak scripts/metview_base.in )

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	chmod +x ./scripts/*.mv
	# Hack. how to do this via ecbuild?
	cp scripts/metview_base.in scripts/metview_base.in.bak
	sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < scripts/metview_base.in \
		> scripts/tmpx && mv scripts/tmpx scripts/metview_base.in
	dh_auto_configure -- \
		-DMETVIEW_SITE=debian  \
		-DCMAKE_BUILD_TYPE=Release \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -lemosR64' \
		-DMETVIEW_EXTRA_INCLUDES='/usr/include/terralib/kernel' \
		-DMAGICS_HAVE_METVIEW=True \
		-DMAGICS_HAVE_NETCDF=True \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DENABLE_RPATHS=Off \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DENABLE_QT5=On  \
		-DGRIB_API_PATH=/usr/lib \
		-DDISABLE_OS_CHECK=On \
		-DFPIC=${FPIC}
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g'  < debian/CONFIG.site.in \
		> $(METVIEW_DIR_DEV)/scripts/CONFIG.site 
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/

override_dh_auto_test:
	@echo "Checks disabled for the moment due to syntax errors in tests" 

override_dh_fixperms-arch:
	dh_fixperms
	chmod 755 debian/metview/$(MV_DIR)/mv_compress
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \; 
	# Hack. Why weren't these already compressed -n ?
	gunzip debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar.gz
	gunzip debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar.gz
	gzip -n debian/metview-data/usr/share/metview/app-defaults/Sample_Drawers.tar
	gzip -n debian/metview-data/usr/share/metview/app-defaults/User_Dir_Frame.tar
